<?php
$table = new wp_easycart_admin_table( );
$table->set_table( 'ec_order', 'order_id' );
$table->set_table_id( 'ec_admin_order_list' );
$table->set_default_sort( 'order_id', 'DESC' );
$table->set_icon( 'tag' );
$table->set_add_new(false, '', '');
$table->set_docs_link ('orders','order-management');
$table->set_join( 'LEFT JOIN ec_orderstatus ON (ec_orderstatus.status_id = ec_order.orderstatus_id)' );
$table->set_list_columns( 
	array(
		array( 
			'name' 	=> 'order_viewed', 
			'label'	=> '',
			'format'=> 'order_viewed'
		),
		array( 
			'name' 	=> 'order_id', 
			'label'	=> 'Order ID',
			'format'=> 'int'
		),
		array( 
			'select'=> "DATE_FORMAT( ec_order.order_date, '%b %d, %Y' ) AS order_date",
			'name' 	=> 'order_date', 
			'label'	=> 'Order Date',
			'format'=> 'string'
		),
		array( 
			'name' 	=> 'grand_total',
			'label'	=> 'Order Total',
			'format'=> 'currency'
		),
		array( 
			'name' 	=> 'billing_first_name',
			'label'	=> 'First Name',
			'format'=> 'string'
		),
		array( 
			'name' 	=> 'billing_last_name',
			'label'	=> 'Last Name',
			'format'=> 'string'
		),
		array( 
			'select'=> 'ec_orderstatus.order_status',
			'name' 	=> 'order_status',
			'label'	=> 'Order Status',
			'format'=> 'string'
		)
	)
);

global $wpdb;
$order_status = $wpdb->get_results( "SELECT ec_orderstatus.status_id AS value, ec_orderstatus.order_status AS label FROM ec_orderstatus ORDER BY status_id ASC" );

$table->set_filters(
	array(
		array(
			'data'		=> $order_status,
			'label'		=> 'Order Status',
			'where'		=> 'ec_order.orderstatus_id = %s'
		),
		
	)
);

$table->set_search_columns(
	array( 'ec_order.order_id', 'ec_order.user_email', 'ec_order.billing_first_name', 'ec_order.billing_last_name', 'ec_order.shipping_first_name', 'ec_order.shipping_last_name', 'ec_orderstatus.order_status' )
);
$table->set_bulk_actions(
	array(
		array(
			'name'	=> 'delete-order',
			'label'	=> 'Delete'
		),
		array(
			'name'	=> 'print-receipt',
			'label'	=> 'Print Receipt'
		),
		array(
			'name'	=> 'print-packing-slip',
			'label'	=> 'Print Packing Slip'
		),
		array(
			'name'	=> 'export-orders-csv',
			'label'	=> 'Export Selected CSV'
		)
		,
		array(
			'name'	=> 'export-orders-csv-all',
			'label'	=> 'Export All CSV'
		),
		array(
			'name'	=> 'mark-orders-viewed',
			'label'	=> 'Mark Selected Viewed'
		),
		array(
			'name'	=> 'mark-orders-not-viewed',
			'label'	=> 'Mark Selected Not Viewed'
		),
		array(
			'name'	=> 'mark-all-orders-viewed',
			'label'	=> 'Mark All Viewed'
		),
		array(
			'name'	=> 'mark-all-orders-not-viewed',
			'label'	=> 'Mark All Not Viewed'
		)
	)
);
$table->set_actions(
	array(
		array(
			'name'	=> 'edit',
			'label'	=> 'Edit',
			'icon' 	=> 'edit'
		),
		array(
			'name'	=> 'delete-order',
			'label'	=> 'Delete',
			'icon'  => 'trash'
		)
	)
);

$table->set_label( 'Order', 'Orders' );
$table->print_table( );
?>